//#endif
// Created by tim on 17.04.23.
//

#ifndef CTUAPEX_EXTRACTIONMETADATA_H
#define CTUAPEX_EXTRACTIONMETADATA_H

#include <metadata/MetaData.h>

class ExtractionMetadata : public metacg::MetaData::Registrar<ExtractionMetadata> {
public:
    static constexpr const char* key ="ExtractionMetadata";

    ExtractionMetadata()=default;

    explicit ExtractionMetadata(const nlohmann::json& j){
        if(j.is_null()){
            SPDLOG_INFO("Could not generate metadata");
        }
        extract=j.get<bool>();
    }

    virtual nlohmann::json to_json() const {
        return extract;
    };

    virtual const char *getKey() const{
        return key;
    }

    void set_decl_node(clang::FunctionDecl *node){mappedDecl=node;};
    clang::FunctionDecl *get_decl_node() const {return mappedDecl;};

    bool isMarkedToExtract(){return extract;};
    void setMarkedToExtract(bool shouldExtract){extract=shouldExtract;}
private:
    clang::FunctionDecl* mappedDecl= nullptr;
    bool extract=false;

};
#endif //CTUAPEX_EXTRACTIONMETADATA_H
