#include "stdio.h"
#include "stdlib.h"
void read_matrix(FILE * fp, int ** matrix, int m, int n) {
		for(int i = 0; i < m; ++i) {
			for(int j = 0; j < n; ++j) {
				fscanf(fp, "%d", &(matrix[i][j]));
			}
		}
}
void write_matrix(FILE * fp, int ** matrix, int m, int n) {
	for(int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			fprintf(fp, "%d ", matrix[i][j]);
		}
		fprintf(fp, "\n");
	}
}
void matrix_mult(int ** A, int m, int n, int ** B, int o, int p, int ** C) {
	if (n != o) {
		perror("Error: matrix dimensions must match");
	} else {
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j < p; ++j) {
				C[i][j] = 0;
				for (int k = 0; k < n; ++k) {
					C[i][j] += A[i][k] * B[k][j];
				}
			}
		}
	}
}
void matrix_mod(int ** A, int m, int n, int x) {
	for(int i = 0; i < m; ++i) {
		for(int j = 0; j < n; ++j) {
			A [i][j] %= x;
		}
	}
}
void kernel_step1(int ** A, int m, int n, int ** B, int o, int p, int ** C, int mod) {
  matrix_mult(A, m, n, B, m, n, C);
  matrix_mod(C, m, n, mod);
}
void kernel_step2(int ** A, int m, int n, int ** B, int o, int p, int ** C, int mod) {
  matrix_mult(B, m, n, C, m, n, A);
  matrix_mod(A, m, n, mod);
}
void kernel_step3(int ** A, int m, int n, int ** B, int o, int p, int ** C, int mod) {
  matrix_mult(C, m, n, A, m, n, B);
  matrix_mod(B, m, n, mod);
}

