//
// Created by mority on 5/9/20.
//

#ifndef CODEFILTER_TEST_MATRIX_MULT_H_
#define CODEFILTER_TEST_MATRIX_MULT_H_

class MatrixCalc {
public:
/*
 * reads a FILE at fp and writes integer values into matrix
 * the data in the file has to fit the given dimensions m and n
 * m is the number of rows and n is the number of columns
 */
    void read_matrix(FILE *fp, int **matrix, int m, int n);

/*
 * writes a matrix into FILE fp
 * m is the number of rows and n is the number of column
 */
    void write_matrix(FILE *fp, int **matrix, int m, int n);

/*
 * multiplies matrices A and B and writes the result to C
 * m is the number of rows and n is the number of columns of matrix A
 * o is the number of rows and p is the number of columns of matrix B
 * n must be equal to o
 * matrix C must have m rows and p columns
 */
    void matrix_mult(int **A, int m, int n, int **B, int o, int p, int **C);

/*
 * modulate all elements of matrix A with x
 * i.e. A[i][j] = A[i][j] % x;
 */
    void matrix_mod(int **A, int m, int n, int x);

/*
 * wrapper for first computation in driving kernel
 */
    void kernel_step1(int **A, int m, int n, int **B, int o, int p, int **C, int mod);

/*
 * wrapper for second computation in driving kernel
 */
    void kernel_step2(int **A, int m, int n, int **B, int o, int p, int **C, int mod);

/*
 * wrapper for third computation in driving kernel
 */
    void kernel_step3(int **A, int m, int n, int **B, int o, int p, int **C, int mod);

};

#endif    // CODEFILTER_TEST_MATRIX_MULT_H_
