mkdir build
cd build
cmake -DUSE_MPI=0 -DCMAKE_EXPORT_COMPILE_COMMANDS=ON ..
cp compile_commands.json ../compile_commands.json
cd ..

# this is the cgcollector from metacg
cgcollector -p build --extra-arg=-I$(clang -print-resource-dir)/include --metacg-format-version=2 lulesh.cc
cgcollector -p build --extra-arg=-I$(clang -print-resource-dir)/include --metacg-format-version=2 lulesh-init.cc
cgcollector -p build --extra-arg=-I$(clang -print-resource-dir)/include --metacg-format-version=2 lulesh-comm.cc
cgcollector -p build --extra-arg=-I$(clang -print-resource-dir)/include --metacg-format-version=2 lulesh-util.cc
cgcollector -p build --extra-arg=-I$(clang -print-resource-dir)/include --metacg-format-version=2 lulesh-viz.cc

echo "null" > merged.ipcg
#this is cgmerge from metacg
cgmerge merged.ipcg *.ipcg

# This is a dirty hack to circumvent the generation of origin data,
# as it is buggy in the current metacg release
sed -i 's/fileProperties/FileProperties/g' merged.ipcg


CTUApex \
--cg-file=merged.ipcg \
--extra-arg=-DUSE_MPI=0 \
--log-level=debug \
lulesh.cc lulesh-init.cc lulesh-comm.cc lulesh-util.cc lulesh-viz.cc 2> log.log
#This should result in 5 files with the names lulesh.mini.cc lulesh-init.mini.cc lulesh-comm.mini.cc lulesh-util.mini.cc lulesh-viz.mini.cc
#which should then be able to be compiled
#The resulting binary is currently not able to be run, as no wrapper script can be generated the does the memory setup
